//F̍ɂMicrosoft Visual Studio 2008pMMXSSE2œǨ؃R[h
//AMD64pɃRpC邱ƂōœKĂȂx86pR[h
//AMD64łMMX͎gps

#include <stdio.h>
#include <tchar.h>
#include <windows.h>
#include <intrin.h>
#include <mmintrin.h>
#include <emmintrin.h>

union DWORDBYTE
{
	DWORD dw;
	BYTE b[4];
};

union DWORDWORD
{
	DWORD dw;
	WORD w[2];
};

union WORDBYTE
{
	WORD w;
	BYTE b[2];
};

BYTE g_MultiplyColorTable[256][256];
BYTE g_AddColorTable[256][256];
BYTE g_SubtractColorTable[256][256];
WORD g_BlendColorAlphaTable[256][256];

void InitColorTable()
{
	DWORD i;
	DWORD j;
	for(i = 0 ; i < 256; i++)
	{
		for(j = 0 ; j < 256; j++)
			g_MultiplyColorTable[i][j] = (BYTE)(i * j / 255);
	}
	for(i = 0 ; i < 256; i++)
	{
		for(j = 0 ; j < 256; j++)
			g_AddColorTable[i][j] = (BYTE)(i + j > 255 ? 255 : i + j);
	}
	for(i = 0 ; i < 256; i++)
	{
		for(j = 0 ; j < 256; j++)
			g_SubtractColorTable[i][j] = (BYTE)(i - j > 255 ? 0 : i - j);
	}
	for(i = 0 ; i < 256; i++)
	{
		for(j = 0 ; j < 256; j++)
			g_BlendColorAlphaTable[i][j] = (WORD)(i * j);
	}
}

inline DWORD MultiplyColor(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	dw.b[0] = (BYTE)((WORD)(*(DWORDBYTE*)&Color1).b[0] * (*(DWORDBYTE*)&Color2).b[0] / 0x00ff);
	dw.b[1] = (BYTE)((WORD)(*(DWORDBYTE*)&Color1).b[1] * (*(DWORDBYTE*)&Color2).b[1] / 0x00ff);
	dw.b[2] = (BYTE)((WORD)(*(DWORDBYTE*)&Color1).b[2] * (*(DWORDBYTE*)&Color2).b[2] / 0x00ff);
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD AddColor(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	WORDBYTE w;
	w.w = (WORD)(*(DWORDBYTE*)&Color1).b[0] + (*(DWORDBYTE*)&Color2).b[0];
	dw.b[0] = w.b[1] ? 0xff : w.b[0];
	w.w = (WORD)(*(DWORDBYTE*)&Color1).b[1] + (*(DWORDBYTE*)&Color2).b[1];
	dw.b[1] = w.b[1] ? 0xff : w.b[0];
	w.w = (WORD)(*(DWORDBYTE*)&Color1).b[2] + (*(DWORDBYTE*)&Color2).b[2];
	dw.b[2] = w.b[1] ? 0xff : w.b[0];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD SubtractColor(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	WORDBYTE w;
	w.w = (WORD)(*(DWORDBYTE*)&Color1).b[0] - (*(DWORDBYTE*)&Color2).b[0];
	dw.b[0] = w.b[1] ? 0 : w.b[0];
	w.w = (WORD)(*(DWORDBYTE*)&Color1).b[1] - (*(DWORDBYTE*)&Color2).b[1];
	dw.b[1] = w.b[1] ? 0 : w.b[0];
	w.w = (WORD)(*(DWORDBYTE*)&Color1).b[2] - (*(DWORDBYTE*)&Color2).b[2];
	dw.b[2] = w.b[1] ? 0 : w.b[0];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD BlendColorAlpha(DWORD Color1, DWORD Color2, DWORD Alpha1, DWORD Alpha2)
{
	DWORDWORD dw[4];
	dw[0].w[0] = (*(DWORDBYTE*)&Color1).b[0];
	dw[0].w[1] = (*(DWORDBYTE*)&Color1).b[1];
	dw[1].w[0] = (*(DWORDBYTE*)&Color1).b[2];
	dw[2].w[0] = (*(DWORDBYTE*)&Color2).b[0];
	dw[2].w[1] = (*(DWORDBYTE*)&Color2).b[1];
	dw[3].w[0] = (*(DWORDBYTE*)&Color2).b[2];
	dw[0].dw = (dw[0].dw * Alpha1 + dw[2].dw * Alpha2) >> 8;
	dw[1].dw = (dw[1].dw * Alpha1 + dw[3].dw * Alpha2) >> 8;
	(*(DWORDBYTE*)&dw[0]).b[1] = (*(DWORDBYTE*)&dw[0]).b[2];
	(*(DWORDBYTE*)&dw[0]).b[2] = (*(DWORDBYTE*)&dw[1]).b[0];
	return dw[0].dw;
}

inline DWORD MultiplyColorTable(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	dw.b[0] = g_MultiplyColorTable[(*(DWORDBYTE*)&Color1).b[0]][(*(DWORDBYTE*)&Color2).b[0]];
	dw.b[1] = g_MultiplyColorTable[(*(DWORDBYTE*)&Color1).b[1]][(*(DWORDBYTE*)&Color2).b[1]];
	dw.b[2] = g_MultiplyColorTable[(*(DWORDBYTE*)&Color1).b[2]][(*(DWORDBYTE*)&Color2).b[2]];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD AddColorTable(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	dw.b[0] = g_AddColorTable[(*(DWORDBYTE*)&Color1).b[0]][(*(DWORDBYTE*)&Color2).b[0]];
	dw.b[1] = g_AddColorTable[(*(DWORDBYTE*)&Color1).b[1]][(*(DWORDBYTE*)&Color2).b[1]];
	dw.b[2] = g_AddColorTable[(*(DWORDBYTE*)&Color1).b[2]][(*(DWORDBYTE*)&Color2).b[2]];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD SubtractColorTable(DWORD Color1, DWORD Color2)
{
	DWORDBYTE dw;
	dw.b[0] = g_SubtractColorTable[(*(DWORDBYTE*)&Color1).b[0]][(*(DWORDBYTE*)&Color2).b[0]];
	dw.b[1] = g_SubtractColorTable[(*(DWORDBYTE*)&Color1).b[1]][(*(DWORDBYTE*)&Color2).b[1]];
	dw.b[2] = g_SubtractColorTable[(*(DWORDBYTE*)&Color1).b[2]][(*(DWORDBYTE*)&Color2).b[2]];
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD BlendColorAlphaTable(DWORD Color1, DWORD Color2, DWORD Alpha1, DWORD Alpha2)
{
	DWORDBYTE dw;
	dw.b[0] = (BYTE)((g_BlendColorAlphaTable[Alpha1][(*(DWORDBYTE*)&Color1).b[0]] + g_BlendColorAlphaTable[Alpha2][(*(DWORDBYTE*)&Color2).b[0]]) >> 8);
	dw.b[1] = (BYTE)((g_BlendColorAlphaTable[Alpha1][(*(DWORDBYTE*)&Color1).b[1]] + g_BlendColorAlphaTable[Alpha2][(*(DWORDBYTE*)&Color2).b[1]]) >> 8);
	dw.b[2] = (BYTE)((g_BlendColorAlphaTable[Alpha1][(*(DWORDBYTE*)&Color1).b[2]] + g_BlendColorAlphaTable[Alpha2][(*(DWORDBYTE*)&Color2).b[2]]) >> 8);
	dw.b[3] =  0;
	return dw.dw;
}

inline DWORD MultiplyColorMMX(DWORD Color1, DWORD Color2)
{
#if defined(_X86_)
	__m64 m64Color1;
	__m64 m64Color2;
	m64Color1 = _mm_unpacklo_pi8(_mm_cvtsi32_si64(Color1), _mm_setzero_si64());
	m64Color2 = _mm_unpacklo_pi8(_mm_cvtsi32_si64(Color2), _mm_setzero_si64());
	m64Color1 = _mm_mullo_pi16(m64Color1, m64Color2);
	m64Color2 = _mm_srli_pi16(m64Color1, 8);
	m64Color1 = _mm_adds_pu16(m64Color1, m64Color2);
	m64Color1 = _mm_adds_pu16(m64Color1, _mm_set1_pi16(0x0001));
	m64Color1 = _mm_srli_pi16(m64Color1, 8);
	m64Color1 = _mm_packs_pu16(m64Color1, _mm_setzero_si64());
	return (DWORD)_mm_cvtsi64_si32(m64Color1) & 0x00ffffff;
#elif defined(_AMD64_)
	return 0;
#endif
}

inline DWORD AddColorMMX(DWORD Color1, DWORD Color2)
{
#if defined(_X86_)
	__m64 m64Color1;
	m64Color1 = _mm_adds_pu8(_mm_cvtsi32_si64(Color1), _mm_cvtsi32_si64(Color2));
	return (DWORD)_mm_cvtsi64_si32(m64Color1) & 0x00ffffff;
#elif defined(_AMD64_)
	return 0;
#endif
}

inline DWORD SubtractColorMMX(DWORD Color1, DWORD Color2)
{
#if defined(_X86_)
	__m64 m64Color1;
	m64Color1 = _mm_subs_pu8(_mm_cvtsi32_si64(Color1), _mm_cvtsi32_si64(Color2));
	return (DWORD)_mm_cvtsi64_si32(m64Color1) & 0x00ffffff;
#elif defined(_AMD64_)
	return 0;
#endif
}

inline DWORD BlendColorAlphaMMX(DWORD Color1, DWORD Color2, DWORD Alpha1, DWORD Alpha2)
{
#if defined(_X86_)
	__m64 m64Color1;
	__m64 m64Color2;
	m64Color1 = _mm_unpacklo_pi8(_mm_cvtsi32_si64(Color1), _mm_setzero_si64());
	m64Color1 = _mm_mullo_pi16(m64Color1, _mm_set1_pi16((short)Alpha1));
	m64Color2 = _mm_unpacklo_pi8(_mm_cvtsi32_si64(Color2), _mm_setzero_si64());
	m64Color2 = _mm_mullo_pi16(m64Color2, _mm_set1_pi16((short)Alpha2));
	m64Color1 = _mm_adds_pu16(m64Color1, m64Color2);
	m64Color1 = _mm_srli_pi16(m64Color1, 8);
	m64Color1 = _mm_packs_pu16(m64Color1, _mm_setzero_si64());
	return (DWORD)_mm_cvtsi64_si32(m64Color1) & 0x00ffffff;
#elif defined(_AMD64_)
	return 0;
#endif
}

inline DWORD MultiplyColorSSE2(DWORD Color1, DWORD Color2)
{
	__m128i m128iColor1;
	__m128i m128iColor2;
	m128iColor1 = _mm_unpacklo_epi8(_mm_cvtsi32_si128(Color1), _mm_setzero_si128());
	m128iColor2 = _mm_unpacklo_epi8(_mm_cvtsi32_si128(Color2), _mm_setzero_si128());
	m128iColor1 = _mm_mullo_epi16(m128iColor1, m128iColor2);
	m128iColor2 = _mm_srli_epi16(m128iColor1, 8);
	m128iColor1 = _mm_adds_epu16(m128iColor1, m128iColor2);
	m128iColor1 = _mm_adds_epu16(m128iColor1, _mm_set1_epi16(0x0001));
	m128iColor1 = _mm_srli_epi16(m128iColor1, 8);
	m128iColor1 = _mm_packus_epi16(m128iColor1, _mm_setzero_si128());
	return (DWORD)_mm_cvtsi128_si32(m128iColor1) & 0x00ffffff;
}

inline DWORD AddColorSSE2(DWORD Color1, DWORD Color2)
{
	__m128i m128iColor1;
	m128iColor1 = _mm_adds_epu8(_mm_cvtsi32_si128(Color1), _mm_cvtsi32_si128(Color2));
	return (DWORD)_mm_cvtsi128_si32(m128iColor1) & 0x00ffffff;
}

inline DWORD SubtractColorSSE2(DWORD Color1, DWORD Color2)
{
	__m128i m128iColor1;
	m128iColor1 = _mm_subs_epu8(_mm_cvtsi32_si128(Color1), _mm_cvtsi32_si128(Color2));
	return (DWORD)_mm_cvtsi128_si32(m128iColor1) & 0x00ffffff;
}

inline DWORD BlendColorAlphaSSE2(DWORD Color1, DWORD Color2, DWORD Alpha1, DWORD Alpha2)
{
	__m128i m128iColor1;
	__m128i m128iColor2;
	m128iColor1 = _mm_unpacklo_epi8(_mm_cvtsi32_si128(Color1), _mm_setzero_si128());
	m128iColor1 = _mm_mullo_epi16(m128iColor1, _mm_set1_epi16((short)Alpha1));
	m128iColor2 = _mm_unpacklo_epi8(_mm_cvtsi32_si128(Color2), _mm_setzero_si128());
	m128iColor2 = _mm_mullo_epi16(m128iColor2, _mm_set1_epi16((short)Alpha2));
	m128iColor1 = _mm_adds_epu16(m128iColor1, m128iColor2);
	m128iColor1 = _mm_srli_epi16(m128iColor1, 8);
	m128iColor1 = _mm_packus_epi16(m128iColor1, _mm_setzero_si128());
	return (DWORD)_mm_cvtsi128_si32(m128iColor1) & 0x00ffffff;
}

inline void EmptyMMXRegister()
{
#if defined(_X86_)
	_mm_empty();
#elif defined(_AMD64_)
#endif
}

BOOL IsMMXAvailable()
{
#if defined(_X86_)
	int CPUInfo[4];
	__m64 i;
	__try
	{
		__cpuid(CPUInfo, 1);
		if(!(CPUInfo[3] & (1 << 23)))
			return FALSE;
		i = _mm_setzero_si64();
		if(_mm_cvtsi64_si32(i))
		{
			EmptyMMXRegister();
			return FALSE;
		}
		EmptyMMXRegister();
	}
	__except(true)
	{
			return FALSE;
	}
	return TRUE;
#elif defined(_AMD64_)
	return FALSE;
#endif
}

BOOL IsSSE2Available()
{
	int CPUInfo[4];
	__m128i i;
	__try
	{
		__cpuid(CPUInfo, 1);
		if(!(CPUInfo[3] & (1 << 26)))
			return FALSE;
		i = _mm_setzero_si128();
		if(_mm_cvtsi128_si32(i))
			return FALSE;
	}
	__except(true)
	{
			return FALSE;
	}
	return TRUE;
}

int _tmain(int argc, _TCHAR* argv[])
{
	DWORD i;
	DWORD j;
	DWORD k;	//[vȗ̍œK}
	LARGE_INTEGER Freq;
	LARGE_INTEGER Start;
	LARGE_INTEGER Finish;
	SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);	//KvɉėDxグ
	_tprintf(_T("Speed Test for Lookup Table, MMX and SSE2 Optimization\n"));
	_tprintf(_T("\n"));
	InitColorTable();
	Sleep(1000);
	QueryPerformanceFrequency(&Freq);
	k = 0;

	//eFől255ŐKꂽ32rbgJ[Z
	Sleep(1000);
	_tprintf(_T("Multiply colors (C = C1 * C2)\n"));
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += MultiplyColor(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Normal\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 1; i++)	//y[WtH[g}ƃLbVi[
	{
		for(j = 0; j < 0x01000000; j++)
			k += MultiplyColorTable(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += MultiplyColorTable(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Table\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	if(IsMMXAvailable())
	{
		Sleep(1000);
		EmptyMMXRegister();
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += MultiplyColorMMX(j, 0x00ffffff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		EmptyMMXRegister();
		_tprintf(_T("MMX\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("MMX is not available on this machine.\n"));
	if(IsSSE2Available())
	{
		Sleep(1000);
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += MultiplyColorSSE2(j, 0x00ffffff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		_tprintf(_T("SSE2\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("SSE2 is not available on this machine.\n"));
	_tprintf(_T("\n"));

	//eFől255ŐKꂽ32rbgJ[Z
	Sleep(1000);
	_tprintf(_T("Add colors with saturation (C = min(C1 + C2, 255))\n"));
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += AddColor(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Normal\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 1; i++)	//y[WtH[g}ƃLbVi[
	{
		for(j = 0; j < 0x01000000; j++)
			k += AddColorTable(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += AddColorTable(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Table\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	if(IsMMXAvailable())
	{
		Sleep(1000);
		EmptyMMXRegister();
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += AddColorMMX(j, 0x00ffffff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		EmptyMMXRegister();
		_tprintf(_T("MMX\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("MMX is not available on this machine.\n"));
	if(IsSSE2Available())
	{
		Sleep(1000);
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += AddColorSSE2(j, 0x00ffffff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		_tprintf(_T("SSE2\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("SSE2 is not available on this machine.\n"));
	_tprintf(_T("\n"));

	//eFől255ŐKꂽ32rbgJ[Z
	Sleep(1000);
	_tprintf(_T("Subtract colors with saturation (C = max(C1 - C2, 0))\n"));
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += SubtractColor(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Normal\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 1; i++)	//y[WtH[g}ƃLbVi[
	{
		for(j = 0; j < 0x01000000; j++)
			k += SubtractColorTable(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += SubtractColorTable(j, 0x00ffffff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Table\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	if(IsMMXAvailable())
	{
		Sleep(1000);
		EmptyMMXRegister();
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += SubtractColorMMX(j, 0x00ffffff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		EmptyMMXRegister();
		_tprintf(_T("MMX\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("MMX is not available on this machine.\n"));
	if(IsSSE2Available())
	{
		Sleep(1000);
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += SubtractColorSSE2(j, 0x00ffffff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		_tprintf(_T("SSE2\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("SSE2 is not available on this machine.\n"));
	_tprintf(_T("\n"));

	//eFől255ŐKꂽ32rbgJ[ƍől256ŐKꂽAt@lŃAt@uh
	//Alpha1Alpha2256w肵Ă͂ȂȂ
	//{Alpha1Alpha2̘a256łׂAAt@ľvZ͍̋cƖ֌WȂ255ɐݒ
	Sleep(1000);
	_tprintf(_T("Blend colors with alpha (C = C1 * A1 + C2 * A2)\n"));
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += BlendColorAlpha(j, 0x00ffffff, j & 0x000000ff, ~j & 0x000000ff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Normal\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	Sleep(1000);
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 1; i++)	//y[WtH[g}ƃLbVi[
	{
		for(j = 0; j < 0x01000000; j++)
			k += BlendColorAlphaTable(j, 0x00ffffff, j & 0x000000ff, ~j & 0x000000ff);
	}
	QueryPerformanceCounter(&Start);
	for(i = 0; i < 10; i++)
	{
		for(j = 0; j < 0x01000000; j++)
			k += BlendColorAlphaTable(j, 0x00ffffff, j & 0x000000ff, ~j & 0x000000ff);
	}
	QueryPerformanceCounter(&Finish);
	Finish.QuadPart -= Start.QuadPart;
	_tprintf(_T("Table\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	if(IsMMXAvailable())
	{
		Sleep(1000);
		EmptyMMXRegister();
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += BlendColorAlphaMMX(j, 0x00ffffff, j & 0x000000ff, ~j & 0x000000ff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		EmptyMMXRegister();
		_tprintf(_T("MMX\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("MMX is not available on this machine.\n"));
	if(IsSSE2Available())
	{
		Sleep(1000);
		QueryPerformanceCounter(&Start);
		for(i = 0; i < 10; i++)
		{
			for(j = 0; j < 0x01000000; j++)
				k += BlendColorAlphaSSE2(j, 0x00ffffff, j & 0x000000ff, ~j & 0x000000ff);
		}
		QueryPerformanceCounter(&Finish);
		Finish.QuadPart -= Start.QuadPart;
		_tprintf(_T("SSE2\t%.7lf sec\n"), 1.0 * Finish.QuadPart / Freq.QuadPart);
	}
	else
		_tprintf(_T("SSE2 is not available on this machine.\n"));
	_tprintf(_T("\n"));

	if(k > 0)
		Sleep(0);
	Sleep(3000);
	return 0;
}

